#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stddef.h>
#include <sys/types.h>
#include <sys/wait.h>

const char *SHELL = "/bin/sh";

pid_t preview (char *program, char *filename)
{
    pid_t pid;
    char buf[256];

    sprintf(buf, "%s %s\n", program, filename);
    
    pid = fork ();
    if (pid == 0)
    {
	/* This is the child process.  Execute the shell command. */
        execl (SHELL, SHELL, "-c", buf, NULL);
        _exit (EXIT_FAILURE);
    }
    else if (pid < 0)
    {
         /* The fork failed.  Report failure.  */
         return -1;
    }
    else
    {
	return pid;
    }
}    

void WaitPid(pid_t pid)
{
    int status;
    waitpid (pid, &status, 0);
}













