#include <stdio.h>


static void init_swaptable(swaptable)
     unsigned char *swaptable;
{
    int i, j;

    for (i = 0; i < 256; i++) {
	j = ( ((i & 0x01) << 7) |
	     ((i & 0x02) << 5) |
	     ((i & 0x04) << 3) |
	     ((i & 0x08) << 1) |
	     ((i & 0x10) >> 1) |
	     ((i & 0x20) >> 3) |
	     ((i & 0x40) >> 5) |
	     ((i & 0x80) >> 7) );
	swaptable[i] = j;
    }
}

/* 
  Reverses the low order 8 bits of a byte
*/

unsigned char swap_bits(c)
     unsigned char c;
{
    static unsigned char swaptable[256];
    static int swaptable_init = 0;

    if (!swaptable_init) {
	init_swaptable(swaptable);
	swaptable_init = 1;
    }

    return(swaptable[c]);
}

main(int ac, char **av)
{
    FILE *fp;
    short i;
    puts("    ");
    
    for(i = 0; i < 256; i++)
    {
	printf("0x%02x,", swap_bits(i));
	if((i & 0x7) == 0x7)
	{
	    fputs("\n    ", stdout);
	}
    }
    return 0;
    
}
