/*******************************************************************************
*
*   Given a prompt,  the number of loose items (1 to 6) and the loose item to
*   be pointed to (numbered from 0) followed by the appropriate number of item
*   strings (up to 20 characters), this function pulls down a confirmation menu.
*
*   An ESC returns -1, while a hit, do or selection by first character returns
*   the item number. Note: the first character of each item string should be
*   Upper Case.
*
*******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <qdos.h>
#include <qptr.h>
#include <stdarg.h>
#include <string.h>

static long MMOVE (struct WM_wwork *);
static struct WM_action mmove = {JSR, wm_actli, MMOVE};
static long ACHOICE (struct WM_wwork *, struct WM_litm *, struct WM_wstat *);
static struct WM_action achoice = {JSR, wm_actli, ACHOICE};
extern struct WM_sprite mes_move;

#define nlitm_max   2
#define pulld_wid   108
#define pulld_hgt   27
#define bord_x      4
#define nlitm       3
#define pr_wid      ((16+1)*6)
#define lit_wid     ((pulld_wid/2)-4)

static int retstat;

void answer(int *pid, int *rval)
{
    static QD_TEXTI (qprompt, "QFAX - Answer ? ");
    static QD_TEXTI (YText, "Yes");
    static QD_TEXTI (NText, "No");
    static struct WM_wstat ws;
    
    static struct WM_info info[1 + 1] =	/* information objects */
    {
	{pr_wid-6, 10,			/* xsize, ysize         size */
         ((pulld_wid - pr_wid) / 2 + 3), 0,/* xorg, yorg           and origin */
	 TYP_TEXT, 0,		/* type, spare          item type */
	 {0, 0, 0},		/* ink, cwid, chgt      character attributes */
	 &qprompt},		/* *pobj                pointer to object */
	{-1}			/* end of array */
    };

    static struct WM_infw infw[2 + 1] =	/* information window */
    {
	{pulld_wid, 12,		/* xsize, ysize size */
	 bord_x, 13,		/* xorg, yorg and origin */
	 0,			/* flag no clear + shadow */
	 1, 0, 7,	        /* borw, borc, papr border width/clr, paper */
	 NULL},			/* *pobj pointer to object list */
	{pulld_wid, 10,		/* xsize, ysize size */
	 bord_x, 1,		/* xorg, yorg and origin */
	 NO_WCLEAR,		/* flag no clear + shadow */
	 0, 0, CL_MBACK,	/* borw, borc, papr border width/clr, paper */
	 info},			/* *pobj pointer to object list */
	{-1}			/* end of array */
    };

    static struct WM_litm litm[nlitm + 1] =	/* loose item */
    {
        {22, 10, 2,  1, 0, 0, 2, K_MOVE,   &mes_move, 0, &mmove},
	{lit_wid, 10,		/* xsize, ysize         size */
	 bord_x+2, 14,		/* xorg, yorg           and origin */
	 0, 0,			/* xjst, yjst           justification */
	 TYP_TEXT - 1, 'Y',	/* type, skey           type and select key */
	 &YText,		/* *pobj                pointer to object */
	 1,			/* item                 item number */
	 &achoice},		/* *pact                pointer to action */

	{lit_wid, 10,   	/* xsize, ysize         size */
	 bord_x+2+54, 14,	/* xorg, yorg           and origin */
	 0, 0,			/* xjst, yjst           justification */
	 TYP_TEXT - 1, 'N',	/* type, skey           type and select key */
	 &NText,		/* *pobj                pointer to object */
	 2,			/* item                 item number */
	 &achoice},		/* *pact                pointer to action */
	{-1}			/* end of array */
    };

    static struct WM_wwork ww =	/* window working definition */
    {
	NULL,			/* wstat  pointer to status area */
	NULL,			/* wscale this was pointer to WDEF */
	0,			/* chid   channel ID */
	NULL,			/* pprec  pointer to pointer record */
	0,			/* psave pointer position saved */
	0, 0, 0, 0,		/* 4 zero */
	NULL,			/* splst pointer to sprite list */
	pulld_wid + bord_x * 2, pulld_hgt,	/* xsize, ysize */
	8, pulld_hgt - 4,	/* xorg, yorg           and origin */
	2,			/* flag no clear + shadow */
	1, CL_MBORD, 7,	        /* borw, borc, papr border width/clr, paper */
	NULL,			/* *sprite pointer to sprite */
	1, CL_MHIGH,		/* curw, curc current item width/clr */
	CL_MPUNAV, CL_MIUNAV, NULL, NULL, /* uback, uink, *ublob, *upatt unavail */
	CL_MPAVBL, CL_MIAVBL, NULL, NULL,	/* aback, aink, *ablob, *apatt avail */
	CL_MPSLCT, CL_MISLCT, NULL, NULL,	/* sback, sink, *sblob, *spatt selected */
	NULL,			/* *help */
	2, 1, infw,		/* ninfo, ninob, *pinfo info winds */
	nlitm, litm,		/* nlitm, *plitm        loose items */
	0, NULL			/* nappl  *pappl        appl winds */
    };

    retstat = -1;
    ww.chid = io_open("scr", 0);

    if (! wm_findv (ww.chid))
    {
        *rval = -1;
        return;
    }

    memset(&ws, '\0', sizeof(struct WM_wstat));
 
    ws.wwork = &ww;		/* cross references */
    ww.wstat = &ws;
    ws.wmode = FORM_QL4;

    ws.citem = -1;		/* no current item  */
    ws.ciact = NULL;		/* or current item routine */
    ws.litem[nlitm] = -1;   	/* preset ESC return */

    wm_prpos (&ww, -1, -1);
    wm_wdraw (&ww);

    while (!wm_rptr (&ww))
    {
	if (ws.evnt & PT_CAN)
	    break;
    }

    wm_cluns (&ww);		/* throw it away */
    *pid = 0;
    *rval = (retstat != 1);
}

static long ACHOICE (struct WM_wwork *wwk, struct WM_litm *li, struct WM_wstat *wst)
{
    retstat = li->item;	        /* set item hit in status area */
    return PT__CAN;		/* and return CAN event */
}
static long MMOVE (struct WM_wwork *wwk)
{
    short dx, dy;

    wwk->wstat->evnt |= PT_WMOVE;	/* set event bit for wm_chwin */
    wm_chwin (wwk, &dx, &dy);	/* move window */
    wwk->wstat->litem[0] = WSI_MKAV;	/* set make available */
    return wm_ldraw (wwk, -1);	/* and re-draw */
}

#ifdef TEST
extern jcall (void (*)(), char *, int, int, int,...);
main()
{
    int pid;
    int rval = 0;
    
    pid = jcall(answer, "Take This Call ?", 1, 2048, 2, &pid, &rval);

    while(pid > 0)
    {
        sleep(1);
    }
    printf("The res was %d\n", rval);
}
#endif
