#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include "qfv.h"

#define RETITM  39

Prototype int menu (struct WM_wwork *, char *, PLLIST *, int, int, int, int, int, struct WM_litm *, int);

static long MACT (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);
static long MDRAW (struct WM_wwork *wwk, struct WM_menw *mw);

static struct WM_action mdraw = {JSR, wm_drwaw, MDRAW};
static struct WM_action mact = {JSR, wm_actme, MACT};

#define MAX_SECT    1
#define MAX_YSIZE   120

static struct WM_info d_info[2] =	/* information objects */
{
    {10, 10,			/* xsize, ysize         size */
     2, 1,			/* xorg, yorg           and origin */
     TYP_TEXT, 0,		/* type, spare          item type */
     {0, 0, 0}, 		/* ink, cwid, chgt      character attributes */
     NULL},			/* *pobj                pointer to object */
    {-1}
};

static struct WM_infw d_infw[3] =
{
    {0, 14,			/* xsize, ysize         size */
     0, 0,			/* xorg, yorg           and origin */
     0,				/* flag                 no clear + shadow */
     0, 0, 127,			/* borw, borc, papr     border width/clr, paper */
     NULL},			/* *pobj                pointer to object list */

    {10, 12,			/* xsize, ysize         size */
     4, 1,			/* xorg, yorg           and origin */
     0,				/* flag                 no clear + shadow */
     0, 0, 7,   		/* borw, borc, papr     border width/clr, paper */
     NULL},			/* *pobj                pointer to object list */
    {-1}
};


static struct WM_menw d_mw =	/* menu window */
{
    0, 0,			/* xsize, ysize         size */
    2, 14,			/* xorg, yorg           and origin */
    0,  			/* flag                 no clear + shadow */
    1, 0, 7,			/* borw, borc, papr     border width/clr, paper */
    NULL,			/* *pspr                pointer to sprite */
    &mdraw,			/* *draw                draw routine */
    wm__mhit,			/* *hit                 hit routine */
    wm__pnsc,			/* *ctrl                control routine */
    0, 0,			/* nxsc, nysc           max x,y sections */
    0, 0, 0,			/* skey, 2 spare        selection keystroke */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
   /*2, 0, 7,*/0,7,0,	                /* psac, psbc, pssc arrow/bar clrs */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
   /*2, 0, 7,*/0,7,0,            	/* psac, psbc, pssc arrow/bar clrs */
    NULL,			/* *mstt                menu status area */
    1, 0,			/* curw, curc           current item width/clr */
    7, 4, NULL, NULL,	/* uback, uink, *ublob, *upatt unavail */
    7, 0, NULL, NULL,	/* aback, aink, *ablob, *apatt  avail */
    0, 7, NULL, NULL,	/* sback, sink, *sblob, *spatt selected */
    1, 0,			/* ncol, nrow           columns and rows */
    0, 0,			/* xoff, yoff           window offset */
    {0, 0},			/* -xsize, -xspce     or *xspc spacing list */
    {-10, -12},			/* -ysize, -yspce     or *yspc spacing list */
    NULL, NULL,			/* *xind, *yind         not implemented */
    NULL			/* *rowl                row list */
};

static struct WM_wwork d_ww =	/* window working definition */
{
    NULL,			/* *wstat;              pointer to status area */
    NULL,			/* *wscale              this was pointer to WDEF */
    0,				/* chid                 channel ID */
    NULL,			/* *pprec               pointer to pointer record */
    0,				/* psave                pointer position saved */
    0, 0, 0, 0,			/* 4 zero */
    NULL,			/* *splst               pointer to sprite list */
    0, 0,			/* xsize, ysize will need changing */
    0, 0,			/* xorg, yorg           and origin */
    2 | NO_WCLEAR,		/* flag                 no clear + shadow */
    1, 0, 127,    		/* borw, borc, papr     border width/clr, paper */
    NULL,			/* *sprite              pointer to sprite */
    1, 0,			/* curw, curc           current item width/clr */
    7, 2, NULL, NULL,	/* uback, uink, *ublob, *upatt  unavail */
    7, 0, NULL, NULL,	/* aback, aink, *ablob, *apatt  avail */
    7, 0, NULL, NULL,	/* sback, sink, *sblob, *spatt  selected */
    NULL,			/* *help */
    2, 1, NULL,			/* ninfo, ninob, *pinfo info winds */
    0, NULL,			/* nlitm, *plitm        loose items */
    1, NULL			/* nappl  *pappl        appl winds */
};

extern struct WM_wwork *QFVww;                 /* Global ref */

int menu (struct WM_wwork *wwk, char *prompt, PLLIST *MList, int icount,
            int xoff, int yoff, int xsize, int ysize, struct WM_litm *plitem,
                int nlitem)
{

    short pr_w = 0;
    struct WM_wstat ws;
    struct WM_info info[2];
    struct WM_infw infw[3];
    struct WM_menw mw;
    struct WM_appl appl[2];
    struct WM_wwork ww;
    int rval;
    short flg = 0;
    
    WM_PWCB (2) pwcy;

    QD_TEXT (25) _prompt;

    memset (&pwcy, '\0', sizeof (pwcy));
    memcpy (info, d_info, sizeof (d_info));
    info[0].pobj = (char *) &_prompt;

    memcpy (infw, d_infw, sizeof (d_infw));
    infw[1].pobl = info;

    memcpy (&mw, &d_mw, sizeof (d_mw));
    appl[0].pappw = (struct WM_appw *) &mw;
    appl[1].pappw = NULL;

    memcpy (&ww, &d_ww, sizeof (d_ww));
    memset (&ws, '\0', sizeof(ws));
    ws.litem[RETITM] = 0;
    
    ww.pappl = ww.splst = appl;
    ww.pinfo = infw;
    ww.plitm = plitem;
    ww.nlitm = nlitem;

    ws.wmode = FORM_QL4;
    ws.wwork = &ww;		/* cross references */
    ww.wstat = &ws;

    QSTRING ((struct QD_text *) &_prompt, prompt, 25);	/* convert c to QL format */
    pr_w = (_prompt.len + 1) * 6;	/* get pix width */

    if (ysize == 0)
    {
        ysize = icount * 12;
    }
    if(ysize > QFVww->ysize - 18)
    {
        ysize = 12*((QFVww->ysize - 18)/12) ;
        yoff = 0;
        flg = 1;
    }

    if(xsize == 0)
    {
        xsize = (((PMDEF) (*MList)->item)->qtext->len) * 6 + 12 +flg*8;
    }
    if(xsize > QFVww->xsize - 12)
    {
        xsize = QFVww->xsize - 12;
        xoff = 0;
    }
    
    info[0].xsize = pr_w - 6;	/* String length */
    infw[0].xsize = xsize;
    infw[1].xsize = pr_w;	/* outer wight window */

    LoadMenu (&mw, (*MList), &mact);

    ww.xsize = xsize;
    mw.xsize = xsize - 4;

    mw.ysize = ysize;

    ww.ysize = 15 + mw.ysize;
    mw.nysc = MAX_SECT;
    mw.ypwcb = (struct WM_pwcb *) &pwcy;
    ww.xorg = 4;
    ww.yorg = 15 + 8;
    mw.xs.c._size = -mw.xsize + 4;
    mw.xs.c._spce = -mw.xsize;

    ws.citem = -1;		/* no current item  */
    ws.ciact = NULL;		/* or current item routine */

    (plitem + (nlitem-1))->xorg = xsize - (plitem + (nlitem-1))->xsize - 4;
    if(*qd.mono == 3)
    {
        mw.uink = 255;
    }
    if(!(((*qd.mono) & 1)))
    {
        mw.ypsac = 2;
        mw.sback = 2;
        mw.sink = 7;
        mw.uink = 2;
        mw.curc = 2;
        mw.borc = 255;        
        infw[0].papr = 84;
    }

    wm_pulld (&ww, wwk->xorg + xoff, wwk->yorg + yoff);	/* pull down */
    wm_wdraw (&ww);

    while (!wm_rptr (&ww))
    {
	if (ws.evnt & PT_CAN)
	    break;
	if(ws.evnt & PT_WMOVE)
	{
	    menu_rems(&mw);
            LoadMenu (&mw, (*MList), &mact);
	    wm_swapp(&ww, 0, -1);
    	    sd_clear(ww.chid, -1);
	    MDRAW(&ww, &mw);
	}
    }

    rval = ws.litem[RETITM];
    
    free (mw.rowl);
    mw.rowl = NULL;
    wm_cluns (&ww);		/* throw it away */

    ww.xorg = ww.yorg = 0;
    return rval;
}

static long MDRAW (struct WM_wwork *wwk, struct WM_menw *mw)
{
    menu_chks (mw);
    wm_index (wwk, (struct WM_swdef *) mw);
    wm_mdraw (wwk, (struct WM_swdef *) mw, 0);
}

static long MACT (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    struct WM_mobj *mobj;

    mobj = mw->rowl[row].rows;	/* current menu object */
    wwk->wstat->litem[RETITM] = mobj->item;
    return PT__CAN;
}
