#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <qdos.h>
#include "qfv.h"

static unsigned char bit[3][8] = {
/*************************
    {0xf0,0xf},
    {0xc0,0x30,0xc,0x3},
 *************************/
    {0x50,0x05},
    {0x40,0x10,0x4,0x1},
    {0x80,0x40,0x20,0x10,0x8,0x4,0x2,0x1}
    };

static void drawline (char *p, short len);
Prototype void ShowLines();

void ShowLines()
{
    short xp;
    short i,j,k;
    short done;

    char p[304], *q;
    short limit;
    
    limit = pv->iline + pv->tline;

    for(i = pv->tline; i < limit;)
    {
        char *s;
        
        pv->aspect++;
        pv->aspect = pv->aspect % 3;
        if(pv->aspect == 0)
        {
            i++;
        }
        memcpy(p, (s = pv->scan + i * pv->F_char), pv->F_char);
        if(pv->mag < 2)
        {
            short llim;

            llim = (3 - 2 * pv->mag);

            q = s;   
            
            for(k = 0; k < llim; k++)
            {
                pv->aspect++;
                pv->aspect = pv->aspect % 3;
                if(pv->aspect == 0)
                {
                    if(++i >= limit)
                    {
                        break;
                    }
                    q += pv->F_char;
                }
                if(++i >= limit)
                {
                    break;
                }
                q += pv->F_char;
                for(j = pv->offset; j < pv->maxbyte; j++)
                {
                    p[j] |= q[j];
	        }
       	    }
	}

        drawline(p + pv->offset, (pv->maxbyte - pv->offset));
        pv->yp++;
        i++;
        if(pv->yp == pv->ysize)
        {
            break;
	}
    }
    pv->white = 0;
}

static void drawline (char *p, short len)
{
    static struct QLRECT qr = {1,1,0,0};

    short j, k, curr_col = 0, cc_count = 0;
    short xp;
    short lim;

    lim = 1 << (pv->mag + 1);
    
    qr.q_y = pv->yp;
    qr.q_x = xp = 0;
    if(pv->white)
    {
        qr.q_width = pv->xsize;
        sd_fill(pv->chan, -1, 7, &qr);
    }
    for (j = 0; j < len; j++)
    {
        for(k = 0; k < lim; k++)
        {
            if(p[j] & bit[pv->mag][k])
            {
	        if (curr_col)
	        {
		    cc_count++;
	        }
	        else
	        {
                    xp += cc_count;
	            curr_col = 1;
		    cc_count = 1;
	        }
	    }
	    else
	    {
	        if (curr_col)
	        {
	            short mr;
                    mr  = (cc_count + xp > pv->xsize) ? pv->xsize - xp : cc_count; 
	            qr.q_width = mr;
	            qr.q_x = xp;
                    sd_fill(pv->chan, -1, 0, &qr);
                    xp += cc_count;

                    curr_col = 0;
		    cc_count = 1;
	        }
	        else
	            cc_count++;
	    }
	}
    }

    if (cc_count)
    {
        if (curr_col)
        {
            short mr = (cc_count + xp > pv->xsize) ? pv->xsize - xp : cc_count; 
            qr.q_width = mr;
            qr.q_x = xp;
            sd_fill(pv->chan, -1, 0, &qr);
	}
    }
}

