#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <qdos.h>
#include "qfv.h"

Prototype short ScrollIt (short);
Prototype void ResetPage   (short);
Prototype short PanIt      (short);
Prototype void CheckSize();

short ScrollIt (short NewTop)
{

    if(NewTop > pv->xline - pv->ht)
    {
        NewTop = pv->xline - pv->ht;
    }

    if(NewTop == pv->tos)
    {
        return 0;
    }

    if(NewTop > pv->tos)                /* Up or down ? */
    {
        if(NewTop > pv->tos + pv->ht)    /* Full screen draw */
        {
            pv->tline = pv->tos = NewTop;
            pv->yp = 0;
            pv->iline = pv->ht;
            pv->white = 1;
            sd_clear(pv->chan, -1);
        }
        else                            /* Scroll some of it */
        {
            int scrollers;
            
            pv->tline = pv->tos + pv->ht;
            pv->iline = NewTop - pv->tos;
            scrollers = pv->iline * 3 /(4 * pv->fct);
            pv->yp = pv->ysize - scrollers;
            sd_scrol(pv->chan, -1, -scrollers);
            pv->tos = NewTop;    
        }
    }
    else
    {
        if(NewTop + pv->ht < pv->tos)
        {
            pv->tline = pv->tos = NewTop;
            pv->yp = 0;
            pv->white = 1;
            pv->iline = pv->ht;
            sd_clear(pv->chan, -1);
        }
        else
        {
            int scrollers;
            pv->tline = NewTop;
            pv->iline = pv->tos - NewTop;
            scrollers = pv->iline * 3 /(4 * pv->fct);
            pv->yp = 0;
            sd_scrol(pv->chan, -1, scrollers);
            pv->tos = NewTop;
        }
    }
    return 1;
}

void ResetPage (short flag)
{
    if(flag)
    {
        pv->tos = 0;
        pv->offset = 0;
    }        
    sd_clear (pv->chan, -1);
    pv->yp = 0;
    pv->aspect = 0;
    pv->fct = 1 << (2 - pv->mag);
    pv->iline = pv->ysize * pv->fct * 4 / 3;
    if(pv->iline > pv->xline)
    {
        pv->iline = pv->xline;
    }
    pv->ht = pv->iline;
    if(pv->tos > pv->xline - pv->ht)
    {
        pv->tos = pv->xline - pv->ht;
    }
    if(pv->tos < 0)
    {
        pv->tos = 0;
    }
    pv->tline = pv->tos;
    CheckSize(pv);
}
short PanIt (short NewOrg)
{
    short oldoff;
    
    NewOrg = NewOrg / 8;
    
    oldoff = pv->offset;
    pv->offset = NewOrg;
    if(pv->offset < 0)
    {
        pv->offset = 0;
    }
    CheckSize(pv);

    if(oldoff != pv->offset)
    {
        pv->yp = 0;
        pv->tline = pv->tos;
        pv->iline = pv->ht;
        pv->white = 1;
        sd_clear(pv->chan, -1);
        return 1;
    }
    else
    {
        return 0;
    }
}
void CheckSize()
{
    short lim;

    lim = 1 << (pv->mag + 1);
    
    pv->maxbyte = (pv->xsize + pv->offset * lim) / lim;
    
    if(pv->maxbyte > pv->F_char)
    {
        pv->maxbyte = pv->F_char;
        pv->offset = (pv->F_char * lim - pv->xsize)/lim;
    }

    if(pv->offset < 0)
    {
        pv->offset = 0;
    }
}
