#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <getopt.h>

typedef struct
{
    char flag[8];
    unchar xpix;
    unchar ypix;
    unchar first;
    unchar last;
    unchar top_l;
    unchar bot_l;
    unchar right;
    unchar mode;
    long  fsize;
    u_char font[4];
} QFONT;



static ushort SH (ushort val)
{
    return (ushort) (val << 8) + (val >> 8);
}
static ulong LG (ulong val)
{
    return (ulong) (((ulong) SH (val & 0xFFFF) << 16) |
		    (ulong) SH(val >> 16));
}

int main(int ac, char **av)
{
    FILE *fp = NULL;

    while(++av,--ac)
    {
	if((fp = fopen(*av, "r")))
	{
	    int pbyte;
	    QFONT qfont;
	    
	    fread(&qfont, sizeof(QFONT), 1, fp);
	    
	    qfont.fsize = LG(qfont.fsize);
	    pbyte = qfont.fsize + sizeof(QFONT) - 4;
	    fprintf(stderr,"%s %2dx%2d (%d - %d) %d\n",
		    *av, qfont.xpix, qfont.ypix, 
		    qfont.first, qfont.last, pbyte);
	    fclose(fp);
	}
    }
    return 0;
}

