#include <stdlib.h>
#include <string.h>
#include "text2g3.h"

extern CODERSTATE *code;

#define F_char (code->pix>> 3)
#define FAXBITS code->mbits

static void GetQData(PPICDEF);

char * MagBits(char *s, int mag, unsigned char mask, int *nb)
{
    int i, j, k;
    
    i = *nb;

    for(k = 0; k < 8; k++)
    {
        for(j = 0; j < mag; j++)
        {
            if(mask & FAXBITS[k])
            {
                *s = *s | i;
            }
            i = i >> 1;
            if(i == 0)
            {
                i = 0x80;
                s++;
            }
        }
    }
    *nb = i;
    return s;    
}

int GetQLRec(PPICDEF p, short res)
{
        
    if(p->line >= p->ypix)
    {
        return 0;
    }

    /*
     * Here we decide if we need new data or just the same again, depending
     * on magnification, aspect ratio etc
     */
     
    if(res == 0)
    {
        switch(p->mag)
        {
            case 1:   
                p->aspect++;
                if(p->aspect > 3)
                {
                    p->aspect = 0;
                }
                if(!p->square && p->aspect == 0)
                {
                    p->ptr += p->llen;
                }
                else
                {
                    p->ptr = p->base + p->line * p->llen;
		    p->line +=2;
		}
                GetQData(p);
		break;
            case 2:
                p->aspect++;
                if(p->aspect > 3)
                {
                    p->aspect = 0;
                }
                if(p->aspect || p->square)
                {
                    p->ptr = p->base + p->line * p->llen;
		    p->line++;
                    GetQData(p);
		}
		break;
            case 3:
                if(!p->square)
                {
                    p->aspect++;
		    if(p->aspect > 3)
		    {
		        p->aspect = 0;
		    }
                    if(p->aspect & 1)
                    {
                        p->ptr = p->base + p->line * p->llen;
                        GetQData(p);
                        p->line++;
		    }
		}
		else
		{
		    p->aspect++;
		    if(p->aspect > 3)
		    {
		        p->aspect = 0;
		    }
		    if((p->aspect & 1) == 0)
		    {
                        p->ptr = p->base + p->line * p->llen;
                        GetQData(p);
                        p->line++;
		    }
		}
		break;
	}
    }
    else
    {
        switch (p->mag)
        {
            case 1:
                p->aspect++;
                if(p->aspect > 3)
                {
                    p->aspect = 0;
                }
                if(p->aspect || p->square)
                {
                    p->ptr = p->base + p->line * p->llen;
		    p->line++;
                    GetQData(p);
		}
		break;
            case 2:
                if(p->aspect == 0)
                {
                    p->ptr = p->base + p->line * p->llen;
		    p->line++;
                    GetQData(p);
                    p->magc++;
                    if(p->magc == 3)
                    {
                        p->aspect++;
                        p->magc = 0;
                    }
                }
                p->aspect++;
                if(p->square)
                {
                    p->aspect = p->aspect % 2;
                }
                else
                {
                    p->aspect = p->aspect % 3;
                }
                break;
            case 3:
                if(p->aspect == 0)
                {
                    p->ptr = p->base + p->line * p->llen;
		    p->line++;
                    GetQData(p);
                }
                p->aspect++;
                p->aspect = p->aspect % (4 - p->square);
                break;
        }

    }        
    return 1;
}
static void GetQData(PPICDEF p)
{
    int i;
    char *s, *r;
    int nb = 0x80;
    short done;
           
    s =  p->pixlin + p->from;

    memset (p->pixlin, 0, F_char);

    r = p->ptr;
    
    for(i = done = 0; !done; )
    {
        unsigned char q, t = 0;
        short j,z;

        for(j = 0; j < 8 && !done; j++)
        {
            z = 1 << (7-j);
            q = ((*r) & z) | ((*(r+1)) & z);
            if(p->invert == 0)
            {
                q ^= z;
            }
            t |= q;
            i++;
            if(i == p->xpix)
            {
                done = 1;
            }
        }
        s = MagBits(s, p->mag, t, &nb);
        r += 2;
    }
}
