#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>

#define DEFX 16
#define DEFY 16
#ifdef F1
#include "deffont1.h"
#define OUTFILE "font1.font"
#else
#include "deffont0.h"
#define OUTFILE "font0.font"
#endif

#define DEFSIZE (sizeof(font))

#ifdef __VMS
typedef unsigned char unchar;
#endif
typedef struct
{
    char flag[8];
    unchar xpix;
    unchar ypix;
    unchar first;
    unchar last;
    unchar top_l;
    unchar bot_l;
    unchar right;
    unchar mode;
    long  fsize;
    unchar font[4];
} QFONT;

static ushort SH (ushort val)
{
    return (ushort) (val << 8) + (val >> 8);
}
static ulong LG (ulong val)
{
    return (ulong) (((ulong) SH (val & 0xFFFF) << 16) |
		    (ulong) SH(val >> 16));
}

int main(void)
{
    int fx;
    QFONT *qfont;
    size_t qfs;
    
    fx = open(OUTFILE, O_CREAT|O_TRUNC|O_WRONLY);
    if(fx < 0)
    {
	perror("creat");
	exit(0);
    }

    if((qfont = malloc(64*1024)))
    {
	    unchar *p,*q;
	    short i,j;

	    memcpy(qfont->flag,"QfaxFont", 8);
	    qfont->xpix = 16;
	    qfont->ypix = 32;
	    qfont->top_l = 2;
	    qfont->bot_l = 2;
	    qfont->right = 1;
	    qfont->first = 0;
	    qfont->last = 255;
	    qfont->mode = 0;
	    
	    q = qfont->font;
            p = font;

	    for(i = 0; i < 256; i++)
	    {
		for(j = 0; j < 16; j++)
		{
                    *q = ~*p++;
		    *(q+2) = *q;
		    q++;
                    *q = ~*p++;
		    *(q+2) = *q;
		    q++;
		    q = q + 2;
		}
	    }
            {
	        int n;
		qfont->fsize = (q - qfont->font);
		qfs = sizeof(QFONT)-4+qfont->fsize;
		qfont->fsize = LG(qfont->fsize);
	        n = write(fx, qfont, qfs);
	        printf("write %d %d\n", n, (q - qfont->font));
            }
    }
    return 0;
}
